#
# Global pruning tool for Eze results
#
#    Author: Yutaka Sasaki, Toyota Technological Institute
#            (Yutaka.Sasaki<AT>toyota-ti.ac.jp)
#

sub usage {
    print "
       Usage: perl prune.pl THRESHOLD < RESULT_FILE  
               (0 =< threshold =< 1.0)  \n";
}

$threshold = $ARGV[0];
if ( $threshold eq "" ) { &usage(); exit(0); }

while ( $line=<STDIN>) {
    chomp( $line );

    $max_v = 0;
    $max_d = "";
    @cand = ();
    foreach $cv ( split( /\s/ , $line )) {
	($c,$v) = split( /\:/, $cv );
        if (($max_c eq "")||($v>$max_v)) {
            $max_c = $c; $max_v = $v;
        }
	if ( $v >= $threshold )  { push( @cand, $c ); }
    }
    if (@cand) { print join( ' ', @cand ),"\n"; }
    else { print "$max_c\n"; }
}
